@echo off
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: ADSDB.BAT: Script for Debugging AutoCAD ADS applications.            ::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: IMPORTANT: This file is for debugging AutoCAD ADS applications.  If  ::
::            you are using AutoCAD Release 11 or earlier, you must     ::
::            set HCDIR in you environment.                             ::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

if not "%1x" == "x" goto ok
    echo syntax is:    adsdb program
    goto over

:ok
set EXPDEBUG=ADS

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Set next line to 12 if using AutoCAD Release 12 or later; otherwise, ::
:: set it to 11.                                                        ::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    set ADS_VERSION=11

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Set next line to the full pathname of ACAD.EXE; for example:         ::
::    set ACADPATH=c:\ACAD11                                            ::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::    set ACADPATH=c:\ACAD11

if not "%ACADPATH%x" == "x" goto journal
    echo PLEASE SET THE VALUE OF ENVIRONMENT VARIABLE ACADPATH IN THIS BATCH FILE
    goto over

:journal
    echo main off > %1.jou
    echo flip on >> %1.jou
    echo load %1 nocode >> %1.jou
    if "%ADS_VERSION%x" == "11x" goto NO_ACAD_ADS

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Read in %ACDCFGF%\ACAD.ADS and echo out "go" and "eip++" for each line. ::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    countapp >> %1.jou

:NO_ACAD_ADS
    echo go >> %1.jou
    echo eip++ >> %1.jou
    echo usc  >> %1.jou
    echo ?main  >> %1.jou
    if "%ADS_VERSION%x" == "12x" goto ver12
    if "%ADS_VERSION%x" == "11x" goto ver11
    echo PLEASE SET THE VALUE OF ENVIRONMENT VARIABLE ADS_VERSION IN THIS BATCH FILE
    goto over

:ver11
    set R386=-priv
:ver12
    echo mdb @@%1.jou %ACADPATH%\acad.exe
    mdb @@%1.jou %ACADPATH%\acad
    goto over

:over
    if exist %1.jou del %1.jou
    set ACADPATH=
    set ADS_VERSION=
    set EXPDEBUG=
    set R386=
