#ifdef __HIGHC__

#define _COM_INIT 0
#define _COM_SEND 1
#define _COM_RECEIVE 2
#define _COM_STATUS 3

#define _COM_CHR7 2
#define _COM_CHR8 3

#define _COM_STOP1 0
#define _COM_STOP2 4

#define _COM_NOPARITY 0
#define _COM_ODDPARITY 8
#define _COM_EVENPARITY 24

#define _COM_110 0
#define _COM_150 32
#define _COM_300 64
#define _COM_600 96
#define _COM_1200 128
#define _COM_2400 160
#define _COM_4800 192
#define _COM_9600 224

#define _DISK_RESET 0
#define _DISK_STATUS 1
#define _DISK_READ 2
#define _DISK_WRITE 3
#define _DISK_VERIFY 4
#define _DISK_FORMAT 5


#ifndef DISKINFO_T_DEFINED
#define DISKINFO_T_DEFINED

struct diskinfo_t {
unsigned short drive;
unsigned short head;
unsigned short track;
unsigned short sector;
unsigned short nsectors;
_far void *buffer;
};

#endif

#define _KEYBRD_READ 0
#define _KEYBRD_READY 1
#define _KEYBRD_SHIFTSTATUS 2

#define _PRINTER_WRITE 0
#define _PRINTER_INIT 1
#define _PRINTER_STATUS 2

#define _TIME_GETCLOCK 0
#define _TIME_SETCLOCK 1

#ifndef _REGS_DEFINED
#define _REGS_DEFINED

struct WORDREGS {
   unsigned int ax;
   unsigned int bx;
   unsigned int cx;
   unsigned int dx;
   unsigned int si;
   unsigned int di;
   unsigned int cflag;
};
struct BYTEREGS {
   unsigned char al, ah, xax[sizeof(int)-2];
   unsigned char bl, bh, xbx[sizeof(int)-2];
   unsigned char cl, ch, xcx[sizeof(int)-2];
   unsigned char dl, dh, xdx[sizeof(int)-2];
};
union REGS {
   struct WORDREGS x;
   struct BYTEREGS h;
   struct BYTEREGS l;
};

struct SREGS {
   unsigned short int es;
   unsigned short int cs;
   unsigned short int ss;
   unsigned short int ds;
};

#endif

extern unsigned _bios_disk(unsigned, struct diskinfo_t *);
extern unsigned _bios_equiplist(void);
extern unsigned _bios_keybrd(unsigned);
extern unsigned _bios_memsize(void);
extern unsigned _bios_printer(unsigned, unsigned, unsigned);
extern unsigned _bios_serialcom(unsigned, unsigned, unsigned);
extern unsigned _bios_timeofday(unsigned, long *);

extern int int86(int ,union REGS *, union REGS *);
extern int int86x(int ,union REGS *, union REGS *,struct SREGS *);

#endif
