/*   dos.h   */

#ifdef __HIGHC__

#ifndef _REGS_DEFINED
#define _REGS_DEFINED

struct WORDREGS {
   unsigned int ax;
   unsigned int bx;
   unsigned int cx;
   unsigned int dx;
   unsigned int si;
   unsigned int di;
   unsigned int cflag;
};
struct BYTEREGS {
   unsigned char al, ah, xax[sizeof(int)-2];
   unsigned char bl, bh, xbx[sizeof(int)-2];
   unsigned char cl, ch, xcx[sizeof(int)-2];
   unsigned char dl, dh, xdx[sizeof(int)-2];
};
union REGS {
   struct WORDREGS x;
   struct BYTEREGS h;
   struct BYTEREGS l;
};

struct SREGS {
   unsigned short int es;
   unsigned short int cs;
   unsigned short int ss;
   unsigned short int ds;
};

#endif

#ifndef _DOSERROR_DEFINED
#define _DOSERROR_DEFINED

struct DOSERROR {
   short int exterror;
   char class;
   char action;
   char locus;
};

#endif

#ifndef _FIND_T_DEFINED
#define _FIND_T_DEFINED

struct find_t {
   char reserved[21];
   char attrib;
   unsigned short int wr_time;
   unsigned short int wr_date;
   long int size;
   char name[13];
};

#endif

#ifndef _DATETIME_T_DEFINED
#define _DATETIME_T_DEFINED

struct dosdate_t {
   unsigned char day;
   unsigned char month;
   unsigned short int year;
   unsigned char dayofweek;
};

struct dostime_t {
   unsigned char hour;
   unsigned char minute;
   unsigned char second;
   unsigned char hsecond;
};

#endif

#ifndef _DISKFREE_T_DEFINED
#define _DISKFREE_T_DEFINED

struct diskfree_t {
   unsigned short total_clusters;
   unsigned short avail_clusters;
   unsigned short sectors_per_cluster;
   unsigned short bytes_per_sector;
};

#endif

#define _HARDERR_IGNORE 0
#define _HARDERR_RETRY 1
#define _HARDERR_ABORT 2
#define _HARDERR_FAIL 3

#define _A_NORMAL 0
#define _A_RDONLY 1
#define _A_HIDDEN 2
#define _A_SYSTEM 4
#define _A_VOLID 8
#define _A_SUBDIR 16
#define _A_ARCH 32

#define FP_SEG(farptr) (*((unsigned *)&(farptr) + 1))
#define FP_OFF(farptr) (*((unsigned *)&(farptr)))

extern unsigned int _osversion;

extern int bdos(int, unsigned int, unsigned int);
extern void _disable(void );
extern unsigned _dos_allocmem(unsigned ,unsigned *);
extern unsigned _dos_close(int );
extern unsigned _dos_creat(char *,unsigned ,int *);
extern unsigned _dos_creatnew(char *,unsigned ,int *);
extern unsigned _dos_findfirst(char *,unsigned ,struct find_t *);
extern unsigned _dos_findnext(struct find_t *);
extern unsigned _dos_freemem(unsigned );
extern void _dos_getdate(struct dosdate_t *);
extern void _dos_getdrive(unsigned *);
extern unsigned _dos_getdiskfree(unsigned ,struct diskfree_t *);
extern unsigned _dos_getfileattr(char *,unsigned *);
extern unsigned _dos_getftime(int ,unsigned *,unsigned *);
extern void _dos_gettime(struct dostime_t *);
extern void _dos_keep(unsigned ,unsigned );
extern unsigned _dos_open(char *,unsigned ,int *);
extern unsigned _dos_setblock(unsigned ,unsigned ,unsigned *);
extern unsigned _dos_setdate(struct dosdate_t *);
extern void _dos_setdrive(unsigned ,unsigned *);
extern unsigned _dos_setfileattr(char *,unsigned );
extern unsigned _dos_setftime(int ,unsigned ,unsigned );
extern unsigned _dos_settime(struct dostime_t *);
extern int dosexterr(struct DOSERROR *);
extern void _enable(void );
extern int intdos(union REGS *, union REGS *);
extern int intdosx(union REGS *, union REGS *,struct SREGS *);
extern int int86(int ,union REGS *, union REGS *);
extern int int86x(int ,union REGS *, union REGS *,struct SREGS *);
extern void segread(struct SREGS *);

extern _far void (* _dos_getvect(unsigned ))();
extern unsigned _dos_read(int ,_far void *,unsigned ,unsigned *);
extern void _dos_setvect(unsigned ,_far void (*v)());
extern unsigned _dos_write(int ,void _far *,unsigned ,unsigned *);

#endif
