################################################################
#
#   Vars.Mak
#
#   This file contains variable definitions common to all of
#   makefiles for the sample programs.  All of the makefiles
#   in the sample program directories include this file.  If
#   you modify the directory hierarchy, modify the ROOTDIR
#   macro to contain the root directory of the compiler
#   installation.  Likewise, if you move any of the tools 
#   out of the Bin subdirectory, modify the appropriate macro.
#
################################################################

#  The root directory of the compiler installation
#  Absolute path, or relative to the directory where MAKE is invoked.
ROOTDIR=..\..\..

#  The compiler's Bin directory -- where the compiler and tools live
BIN=$(ROOTDIR)\bin

#  The compiler driver
HC=$(BIN)\hc386

#  The bind utility
MWBIND=$(BIN)\mwbind.exe

#  The Windows supervisor
MWSUP=$(BIN)\mwsup.exe

# The 32-bit DLL supervisor
DLLSUP=$(BIN)\mwdllsup.exe

# The 32-bit import librarian
MWIMPLIB=$(BIN)\mwimplib.exe

# The include directory
INCDIR=$(ROOTDIR)\inc

# The command to run the resource compiler
RC=rc
# NOTE:  The INCLUDE environment variable must be set to the SDK include
#        directory so the resource compiler will get the 16-bit headers.

